SystemOrganization addCategory: #'AST-Interpreter-Parser'!

RBParser subclass: #RBExplicitVariableParser
	instanceVariableNames: 'currentVariableNodeClass currentScope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AST-Interpreter-Parser'!

!RBExplicitVariableParser methodsFor: 'private-classes' stamp: 'CamilloBruni 12/15/2011 16:16'!
argumentNodeClass
	^ RBArgumentNode! !

!RBExplicitVariableParser methodsFor: 'private-classes' stamp: 'CamilloBruni 12/15/2011 16:35'!
lookupVariableNodeClass: aName
	| scope |
	
	currentVariableNodeClass notNil ifTrue: [ ^ currentVariableNodeClass ].
	scope := currentScope.
	[ scope isNil ]  whileFalse: [
		(scope hasTemporaryNamed: aName) ifTrue: [ ^ RBTemporaryNode ].
		(scope hasArgumentNamed: aName) ifTrue: [ ^ RBArgumentNode ].
		scope := scope scope.
	].
	
	^ RBVariableNode! !

!RBExplicitVariableParser methodsFor: 'private-parsing' stamp: 'CamilloBruni 12/15/2011 16:40'!
parseBlock
	| position node |
	position := currentToken start.
	self step.
	node := self blockNodeClass new. 
	self pushScope: node.
	
	self useVariable: RBArgumentNode during: [ self parseBlockArgsInto: node ].
	node left: position.
	
	node body: self sequenceNodeClass new.
	(self parseStatements: false into: node body).
	
	(currentToken isSpecial and: [currentToken value = $]])
		ifFalse: [self parserError: ''']'' expected'].
	node right: currentToken start.
	
	self step.
	self popScope.
	^node! !

!RBExplicitVariableParser methodsFor: 'private-parsing' stamp: 'CamilloBruni 12/15/2011 16:40'!
parseMethod
	| methodNode | 
	
	self useVariable: RBArgumentNode during: [methodNode := self parseMessagePattern].
	
	self pushScope: methodNode.
	
	self parsePragmas.
	self addCommentsTo: methodNode.
	
	methodNode body: self sequenceNodeClass new.
	(self parseStatements: false into: methodNode body).
	
	pragmas isNil
		ifFalse: [ methodNode pragmas: pragmas ].
	^methodNode! !

!RBExplicitVariableParser methodsFor: 'private-parsing' stamp: 'CamilloBruni 12/15/2011 16:30'!
parsePrimitiveIdentifier
	| token node |
	token := currentToken.
	self step.
	node := (self lookupVariableNodeClass: token value) identifierToken: token.
	self addCommentsTo: node.
	^node! !

!RBExplicitVariableParser methodsFor: 'private-parsing' stamp: 'CamilloBruni 12/15/2011 16:17'!
parseTemps
	| args |
	args := OrderedCollection new.
	self useVariable: RBTemporaryNode during: [
		[currentToken isIdentifier] whileTrue: [args add: self parseVariableNode]].
	^args! !

!RBExplicitVariableParser methodsFor: 'scoping' stamp: 'CamilloBruni 12/15/2011 16:27'!
popScope
	currentScope := currentScope scope! !

!RBExplicitVariableParser methodsFor: 'scoping' stamp: 'CamilloBruni 12/15/2011 16:27'!
pushScope: aNode
	aNode scope: currentScope.
	currentScope := aNode! !

!RBExplicitVariableParser methodsFor: 'private-classes' stamp: 'CamilloBruni 12/15/2011 16:16'!
selfNodeClass
	^ RBSelfNode! !

!RBExplicitVariableParser methodsFor: 'private-classes' stamp: 'CamilloBruni 12/15/2011 16:16'!
superNodeClass
	^ RBSuperNode! !

!RBExplicitVariableParser methodsFor: 'private-classes' stamp: 'CamilloBruni 12/15/2011 16:16'!
temporaryNodeClass
	^ RBTemporaryNode! !

!RBExplicitVariableParser methodsFor: 'private-classes' stamp: 'CamilloBruni 12/15/2011 16:16'!
thisContextNodeClass
	^ RBThisContextNode! !

!RBExplicitVariableParser methodsFor: 'private-classes' stamp: 'CamilloBruni 12/15/2011 16:15'!
useVariable: aVariableNodeClass during: aBlock
	currentVariableNodeClass := aVariableNodeClass.
	^ aBlock ensure: [ currentVariableNodeClass := nil]! !

!RBExplicitVariableParser methodsFor: 'private-classes' stamp: 'CamilloBruni 12/15/2011 16:15'!
variableNodeClass
	^ currentVariableNodeClass ifNil: [ RBVariableNode ]! !
